﻿Imports System.Windows.Forms
Imports System.IO
Imports System.Web.Script.Serialization
Public Class Dialog3

    'DISABLE ALL WIDGETSX
    Private Sub Dialog3_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        TextBox1.Enabled = False
        exportType.Enabled = False
        ComboBox2.Enabled = False
        ListBox1.SelectedIndex = -1
    End Sub

    Private Sub resetToDefaults_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        TextBox1.Enabled = False
        exportType.Enabled = False
        ComboBox2.Enabled = False
        ListBox1.SelectedIndex = -1
        Try
            Dim input As String = ""
            Dim jsonString As String
            Dim sr As StreamReader = File.OpenText(applicationDirectory & "\default.cfg")
            Dim serializer As New JavaScriptSerializer

            variables.Clear()

            Do While sr.Peek() <> -1
                jsonString = sr.ReadLine()
                variables.Add(serializer.Deserialize(Of variable)(jsonString))
            Loop
            sr.Close()
        Catch ex As Exception
            MsgBox("Load Default Settings: " & ex.Message)
        End Try
    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Form1.loadSettings()
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        If ListBox1.SelectedIndex <> -1 Then
            TextBox1.Enabled = True
            exportType.Enabled = True
            ComboBox2.Enabled = True
            Dim v As variable = variables(ListBox1.SelectedIndex)
            TextBox1.Text = v.name
            exportType.SelectedIndex = v.type
            If v.export Then
                ComboBox2.SelectedIndex = 1
            Else
                ComboBox2.SelectedIndex = 0
            End If
        End If
    End Sub

    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress
        If e.KeyChar = Chr(13) Then
            e.Handled = True
            If ListBox1.SelectedIndex <> -1 Then
                Dim v As variable = variables(ListBox1.SelectedIndex)
                v.name = TextBox1.Text
            End If
        End If
    End Sub



    Private Sub exportType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles exportType.SelectedIndexChanged
        If ListBox1.SelectedIndex <> -1 Then
            Dim v As variable = variables(ListBox1.SelectedIndex)
            v.type = exportType.SelectedIndex
        End If
    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
        If ListBox1.SelectedIndex <> -1 Then
            Dim v As variable = variables(ListBox1.SelectedIndex)
            v.export = CBool(ComboBox2.SelectedIndex)
        End If
    End Sub

    Private Sub guiNewWidgetCommand_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles guiNewWidgetCommand.KeyPress
        If e.KeyChar = Chr(13) Then
            e.Handled = True
            guiCall = guiNewWidgetCommand.Text
        End If
    End Sub

    Private Sub padOutputCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles padOutputCheckBox.CheckedChanged
        padOutput = padOutputCheckBox.Checked
    End Sub

    Private Sub singleLineCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles singleLineCheckBox.CheckedChanged
        singleLineMode = singleLineCheckBox.Checked
    End Sub

    Private Sub padWidthTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles padWidthTextBox.KeyPress
        Dim allowedChars As String = "0123456789"
        If e.KeyChar = Chr(13) Or allowedChars.IndexOf(e.KeyChar) = -1 Then
            e.Handled = True
            padWidth = CInt(padWidthTextBox.Text)
        End If
    End Sub

    Private Sub tabWidthTextBox_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles tabWidthTextBox.KeyPress
        Dim allowedChars As String = "0123456789"
        If e.KeyChar = Chr(13) Or allowedChars.IndexOf(e.KeyChar) = -1 Then
            e.Handled = True
            tabWidth = CInt(tabWidthTextBox.Text)
        End If
    End Sub

End Class
